/*
 * Copyright (c) 1994 Berkeley Software Design, Inc. All rights reserved.
 * The Berkeley Software Design Inc. software License Agreement specifies
 * the terms and conditions for redistribution.
 *
 */

#include <db.h>
#include "pwdt.h"
#include <signal.h>
#include <stdio.h>
#include <unistd.h>

#include "libpasswd.h"

void
pw_abort(pw)
	struct pwinfo *pw;
{
	FILE *fp;

	if (pw->pw_flags & PW_RMIDB)
		unlink(pw->pw_idb.pf_name);
	if (pw->pw_flags & PW_RMSDB)
		unlink(pw->pw_sdb.pf_name);
	if (pw->pw_flags & PW_RMOLD)
		unlink(pw->pw_old.pf_name);
	if (pw->pw_flags & PW_RMNEW)
		unlink(pw->pw_new.pf_name);
	pw->pw_flags &= PW__USER | PW_LOCKED;
	fp = pw->pw_master.pf_fp;
	pw->pw_master.pf_fp = NULL;
	if (fp != NULL && fp != pw->pw_lock.pf_fp)
		fclose(fp);
}
