/*
 * Copyright (c) 1989, 1993
 *	The Regents of the University of California.  All rights reserved.
 * (c) UNIX System Laboratories, Inc.
 * All or some portions of this file are derived from material licensed
 * to the University of California by American Telephone and Telegraph
 * Co. or Unix System Laboratories, Inc. and are reproduced herein with
 * the permission of UNIX System Laboratories, Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#ifndef _PWDT_H_
#define	_PWDT_H_

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifdef HAVE_PATHS_H
#include <paths.h>
#endif

#include <sys/types.h>

#ifndef _POSIX_SOURCE
extern char _PATH_PWDT[];		/* "/etc" */
extern char _PATH_PASSWDT[];		/* "/etc/passwd" */
extern char _PASSWDT[];			/* "passwd" */
extern char _PATH_MASTERPASSWDT[];	/* "/etc/master.passwd" */
extern char _MASTERPASSWDT[];		/* "master.passwd" */

extern char _PATH_MP_DBT[];		/* "/etc/pwd.db" */
extern char _MP_DBT[];			/* "pwd.db" */
extern char _PATH_SMP_DBT[];		/* "/etc/spwd.db" */
extern char _SMP_DBT[];			/* "spwd.db" */

#define	_PW_KEYBYNAMET		'1'	/* stored by name */
#define	_PW_KEYBYNUMT		'2'	/* stored by entry in the "file" */
#define	_PW_KEYBYUIDT		'3'	/* stored by uid */

/* #define	_PASSWORD_EFMT1		'_' */	/* extended encryption format */

/* #define	_PASSWORD_LEN		128 */	/* max length, not counting NULL */
#endif

#include <pwd.h>

#ifndef __P
# ifdef __STDC__
#  define __P(x) x
# else
#  define __P(x) ()
#  define const
# endif
#endif
#ifndef __BEGIN_DECLS
#if defined(__cplusplus)
#define __BEGIN_DECLS   extern "C" {
#define __END_DECLS     };
#else
#define __BEGIN_DECLS
#define __END_DECLS
#endif
#endif

__BEGIN_DECLS
struct passwd	*getpwuidt __P((uid_t));
struct passwd	*getpwnamt __P((const char *));
#ifndef _POSIX_SOURCE
struct passwd	*getpwentt __P((void));
int		 setpassentt __P((int));
int		 setpwentt __P((void));
void		 endpwentt __P((void));
char		*user_from_uidt __P((uid_t, int));

void		setpwfilet __P((const char *));
#endif
__END_DECLS

#endif /* !_PWDT_H_ */
