#include <sys/types.h>
#include <fcntl.h>
#include <ttyent.h>
#include <strings.h>
#include <unistd.h>
#include "own_wtmp.h"
#include "libutil.h"
#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif

extern void logwtmp(char *, char *, char *, struct in_addr);

int init_utmp(char *reason) {
    UTMP_T u;
    int f = -1;

    if (setttyent()) {
	if ((f = open(TAC_PLUS_UTMPFILE, O_WRONLY|O_CREAT|O_TRUNC, 0664)) >= 0) {
	    struct in_addr a;
	    a.s_addr = INADDR_ANY;

	    bzero(&u, sizeof(u));
	    time(&u.ut_time);

	    while (getttyent())
		write(f, &u, sizeof(u));

	    close(f);
	    logwtmp("~", reason, "", a);
	}
	endttyent();
    }

    return (f < 0);
}
