/*
 * Copyright (c) 1988, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include <ttyent.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include "own_wtmp.h"
#include "libutil.h"

static char *nextvalid(p)
char **p;
{
  char	*ppp;

  while(**p && ((**p == ' ') || (**p == '\t'))) (*p)++;
  if(!*(ppp = *p) || *ppp == '#')
    return NULL;

  while(**p && (**p != ' ') && (**p != '\t')) (*p)++;
  if(**p)
   {
    **p = '\0';
    (*p)++;
   }

  return ppp;
}

int
t_ttyslot(name, host, alias, trueline, status)
char *name, *host, *alias, **trueline;
int *status;
{
	register struct ttyent *ttyp;
	register int slot;
	char *p, *s;

		/* alias name as original		*/
        strncpy(*trueline, name, UT_LINESIZE);

	if(!setttyent())
	  return 0;
        for (slot = 1; (ttyp = t_getttyent(*status)); ++slot)
         {
         	/* check alias (if need), then host	*/
          if((*status & A_FLAG_TTYS) && alias &&
             !strncmp(ttyp->ty_getty, alias, UT_HOSTSIZE))
           {
            ttyp->ty_status |= A_FLAG_FOUND_AL;
           }
          else if (strncmp(ttyp->ty_getty, host, UT_HOSTSIZE))
            continue;

            	/* check alias	*/
	  if (!strncmp(ttyp->ty_name, name, UT_LINESIZE))
           {
	    *status = ttyp->ty_status;
	    endttyent();
            return(slot);
           }
	    	/* check ports	*/
          if((p = ttyp->ty_comment) != NULL)
            while((s = nextvalid(&p)) != NULL)
              if(!strncmp(s, name, UT_LINESIZE))
               {
                strncpy(*trueline, ttyp->ty_name, UT_LINESIZE);
	        *status = ttyp->ty_status;
	        endttyent();
                return(slot);
               }
         }

	endttyent();
	return(0);
}
