#include <stdio.h>
#include <strings.h>
#include <sys/types.h>
#include "own_wtmp.h"
#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif
extern void login(UTMP_T *, int);
#define ACCT_TYPE_START 1
#define ACCT_TYPE_STOP 2

int main(int ac, char *av[]) {
    UTMP_T u;
    int l;
    char *progname;

    if ((progname = strrchr(av[0], '/')) == NULL)
	progname = av[0];
    else
	progname++;

    l = (strcmp(progname, "logtac") == 0);

    if (ac != 3 + l) {
	fprintf(stderr, "Usage: %s tty nas %s\n", progname, l ? "user" : "");
	exit(1);
    }
    bzero(&u, sizeof(u));
    strncpy(u.ut_line, av[1], UT_LINESIZE-1);
    strncpy(u.ut_host, av[2], UT_HOSTSIZE-1);
    if (l)
	strncpy(u.ut_user, av[3], UT_NAMESIZE-1);
    time(&u.ut_time);
    u.ut_addr.s_addr = INADDR_ANY;
    login(&u, l ? ACCT_TYPE_START : ACCT_TYPE_STOP);
    return 0;
}
