#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdlib.h>

struct alist {				/* daemon access list */
	u_long addr;			/* allowed-address    */
	struct alist *next;
};
static struct alist *a_list = (struct alist *) 0;

int put_new_allow_addr(const char *q) {
	struct alist *al;
	u_long a = inet_addr(q);

	if (!a) return 1;
	al = (struct alist *)malloc(sizeof(struct alist));
	if (!al) return 1;
	al->next = a_list;
	a_list = al;
	al->addr = a;
	return 0;
}

/*
 * Check if daemon connection allowed from given address
 */
int allowaddr(u_long a) {
	struct alist *al;

	if (!a_list)	/* no addresses defined - permit all */
		return 1;
	for (al = a_list; al; al = al->next)
		if (al->addr == a)
			return 1;
	return 0;
}
