/*
 * advanced tacacs+ server based on Cisco Systems tac_plus code.
 * For Cisco copyright notice, see LICENSE.CISCO
 *
 * This is a copyrighted commercial software; see LICENSE for details.
 */

#define DPORT           22736           /* default daemon port no. */
#define MAXARGBUF       256

struct dynp {                           /* Interprocess protocol          */
	char    argb[MAXARGBUF];        /* Argument buffer                */
	int     op;                     /* Operation                      */
	int     serial;                 /* Serial #                       */
	int     magic;                  /* magic number                   */
};

#define DYNP_IARQ       1               /* address request                */
#define DYNP_IAREPL     2               /* reply                          */
#define DYNP_IERROR     3               /* error                          */
#define DYNP_IARQ2      4               /* addr. req. from definite pool  */
#define DYNP_LONOT      5               /* logout notification            */
#define DYNP_LINOT      6               /* login notification             */
#define DYNP_OKAY       7               /* successful zero-reply          */
#define DYNP_MAGIC      0xFABAAA5A      /* magic cookie                   */
