/* 
   Copyright (c) 1995-2000 by Cisco systems, Inc.

   Permission to use, copy, modify, and distribute modified and
   unmodified copies of this software for any purpose and without fee is
   hereby granted, provided that (a) this copyright and permission notice
   appear on all copies of the software and supporting documentation, (b)
   the name of Cisco Systems, Inc. not be used in advertising or
   publicity pertaining to distribution of the program without specific
   prior permission, and (c) notice be given in supporting documentation
   that use, modification, copying and distribution is by permission of
   Cisco Systems, Inc.

   Cisco Systems, Inc. makes no representations about the suitability
   of this software for any purpose.  THIS SOFTWARE IS PROVIDED ``AS
   IS'' AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
   WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
   FITNESS FOR A PARTICULAR PURPOSE.
*/

/* Keywords & values */

typedef enum {
S_key,
S_user,
S_group,
S_host,
S_accounting,
S_name,
S_login,
S_member,
S_expires,
S_cleartext,
S_message,
S_arap,
S_chap,
S_after,
S_pap,
S_svc,
S_before,
S_acct_start,
S_acct_stop,
S_acct_update,
S_default,
S_access,
S_deny,
S_permit,
S_exec,
S_protocol,
S_optional,
S_ip,
S_ipx,
S_slip,
S_ppp,
S_file,
S_skey,
S_authorization,
S_authentication,
S_cmd,
S_attr,
S_lcp,
S_global,
S_des,
S_opap,
#ifdef MAXSESS
S_maxsess,
#endif
#ifdef MSCHAP
S_mschap,
#endif
#if defined(AUTO_MEMBERS)
S_users,
#if defined(AM_REGEXP)
S_newuser,
#endif
#endif
#if defined(NONE_LOGIN) || defined(PERUSER_ENABLE)
S_none,
S_nopasswd,
#endif
#ifdef UNIX_LOGIN
S_prompt,
S_reject,
#endif
#ifdef PERUSER_ENABLE
S_enable,
#endif
#ifdef EMESSAGE
S_emessage,
#endif
#ifdef DENY
S_admdeny,
#endif
#ifdef CRON
S_crondeny,
#endif
#ifdef UDB
S_db,
#if defined(AUTO_MEMBERS) && defined(AM_REGEXP) && defined(MORE_SUBST)
S_db_user,
#endif
#endif
#ifdef ACL
S_tty,
S_nasgrp,
S_from,
S_time,
S_agroup,
#ifdef DXS1
S_dxs1,
#endif
#endif
#ifdef DYNA
S_dynip,
S_apool,
#endif
S_allow_from,
S_listen_on,
#ifdef TAC_SMB_AUTH
S_smb,
S_smbprimary,
S_smbbackup,
S_smbdomain,
#endif
#ifdef TAC_LDAP_AUTH
S_ldap,
S_ldapserver,
S_ldapbasedn,
S_ldapbinddn,
S_ldapbindpw,
#if defined(TAC_LDAP_VERSION3) && defined(TAC_LDAP_SASL)
S_ldapsaslmech,
S_ldapsaslcred,
#endif
#if defined(TAC_LDAP_VERSION3) && defined(TAC_LDAP_NS_SSL)
S_ldapsslpath,
#endif
#endif
#ifdef TAC_DCE_AUTH
S_dce,
#endif
#ifdef EXTERN_AUTHEN
S_extern,
#endif
S_nas,
S_nasaddr,
S_rshuser,
#ifdef ENABLE_SNMP
S_snmpcomm,
#endif
#ifdef TAC_ROAMING
S_tacacs,
S_traddr,
#endif
#ifdef RAD_ROAMING
S_radius,
S_authhost1,
S_authhost2,
S_accthost1,
S_accthost2,
S_secret,
#endif
S_eof,
S_unknown,
S_separator,
S_string,
S_openbra,
S_closebra,
S_svc_dflt
} cfg_token;
