#include "tac_plus.h"
#include <ttyent.h>
#include <ctype.h>
#include "own_wtmp.h"

regex_t rship_re;
extern int timed_read(int, u_char *, int, int);

void reg_nas_users(void) {
#if 0
/* FIXME remove code within #if 0's */
#define MAXNAS 16
    struct ttyent *ttyp;
    char *pnas[MAXNAS];
    int nnas=0;
    int j;

    if(!setttyent()) return;
    for(;(ttyp = getttyent());) {
	int i=0, j=0;
	while(i<nnas)
	    if(!strcmp(pnas[i++],ttyp->ty_getty))
		j=1;
	if(!j) {
	    if (nnas++ < MAXNAS)
		pnas[nnas-1]=strdup(ttyp->ty_getty);
	    else
		report(LOG_WARNING, "reg_nas_users: max number of NAS=%i exceeded",MAXNAS);
	}
    }

for(j=0;j<nnas;j++) {
    char *nas=pnas[j]; /* pnas[j] contains found NAS */
#endif

for (nas_new = nas_list; nas_new; nas_new = nas_new->next) {
    struct sockaddr_in sin;
    struct servent *serv;
    int s, bufsize;
    char *buf, *p, *pn, *pold;
    int incr = 4096, slop = 32;
    long useroff = 13, hostoff = 23;

    /*
     * The finger service, aka port 79
     */
    serv = getservbyname("finger", "tcp");
    if (serv) {
	sin.sin_port = serv->s_port;
    } else {
	sin.sin_port = 79;
    }

#if 0
    u_long inaddr;
    /*
     * Get IP addr for the NAS
     */
    inaddr = inet_addr(nas);
    if (inaddr != -1) {
	/* A dotted decimal address */
	bcopy(&inaddr, &sin.sin_addr, sizeof(inaddr));
	sin.sin_family = AF_INET;
    } else {
	int flags;
	char *nas_alias = get_peer_alias(nas, &flags);
	struct hostent *host = gethostbyname(nas_alias);
	free(nas_alias);
	session.peeralias = get_peer_alias(session.peer, &session.flags);
	if (host == NULL) {
	    report(LOG_ERR, "reg_nas_users: gethostbyname %s failure: %s",
		   nas, strerror(errno));
	    continue;
	}
	bcopy(host->h_addr, &sin.sin_addr, host->h_length);
	sin.sin_family = host->h_addrtype;
    }
#else
    sin.sin_addr.s_addr = nas_new->addr.s_addr;
    sin.sin_family = AF_INET;
#endif

    s = socket(AF_INET, SOCK_STREAM, 0);
    if (s < 0) {
	report(LOG_ERR, "reg_nas_users: NAS %s socket: %s", inet_ntoa(nas_new->addr), strerror(errno));
	continue;
    }

    if (connect(s, (struct sockaddr *)&sin, sizeof(sin)) < 0) {
	report(LOG_ERR, "reg_nas_users: NAS %s connect failure %s", inet_ntoa(nas_new->addr), strerror(errno));
	close(s);
	continue;
    }

    /* Read in the finger output into a single flat buffer */
    buf = NULL;
    bufsize = 0;
    for (;;) {
	int x;

	buf = tac_realloc(buf, bufsize + incr + slop);
	x = timed_read(s, buf + bufsize, incr, 10);
	if (x <= 0) {
	    break;
	}
	bufsize += x;
    }

    /* Done talking here */
    close(s);
    if (bufsize <= 0) {
	report(LOG_ERR, "regnasusers: finger failure");
	free(buf);
	return;
    }
    buf[bufsize] = '\0';
    /* skip first (empty) line in buffer */
    p = strchr(buf, '\n');
    if (p) p++;

    /* skip possible banner */
    pn = strstr(p, "Line");
    if ( pn != NULL ) {
      while ((pn > p) && (*pn != '\n'))
	pn--;
      if (*pn == '\n')
	pn++;
      p = pn;
    }

    pn = strstr(p, "Host");
    if (pn != NULL) hostoff = (pn - p);
    pn = strstr(p, "User");
    if (pn != NULL) useroff = (pn - p);

    p = strchr(p, '\n');
    if (p) p++;

    /*
     * Tally each time this user appears
     */
    for (; p && *p; p = pn) {
	char ttyname[16]="tty";
	UTMP_T u;

	/*
	 * Find next line
	 */
	pn = strchr(p, '\n');
	if (pn) ++pn;

#if 0
	/* Always ignore the NAS/port we're currently trying to login on. */
	if (curport && isdigit(*curport)) {
	    int thisport;

	    if (sscanf(p + 1, " %d", &thisport) == 1) {
		if (atoi(curport) == thisport) {
		    continue;
		}
	    }
	}
#endif

	*(p+hostoff) = ' ';
	/* Extract username */
	pold = p;
	p++;
	p = strtok(p, " \t");
	strncat(ttyname,p,12);
	strtok(NULL, " \t");
	strtok(NULL, " \t");
	p = strtok(NULL, " \t");

	if (p>pold+useroff) continue;

	bzero(&u, sizeof(u));
	strncpy(u.ut_line, ttyname, UT_LINESIZE);
	strncpy(u.ut_host, inet_ntoa(nas_new->addr), UT_HOSTSIZE);
	strncpy(u.ut_user, p, UT_NAMESIZE);
	time(&u.ut_time);
	report(LOG_INFO, "reg_nas_users: found user `%s' on NAS `%s' on `%s'", u.ut_user, u.ut_host, u.ut_line);
	/* login(&u, ACCT_TYPE_START); not worked -- aliases not processed */
	{
	  int tty;
	  int status = A_FLAG_UTMP_TR | A_FLAG_PUTMP_AL | A_FLAG_TTYS;
	  char x[UT_LINESIZE];
	  char *trueline = x;
	  int flags;
	  char *alias = get_peer_alias(u.ut_host, &flags);
#ifdef DYNA
	  char nasinfo[32];
	  regmatch_t pmatch[2];
	  char *buf;
	  char cmd[256];

	  trueline=ttyname;
	  if (!strncmp(ttyname, "Async", 5) || !strncmp(ttyname, "tty", 3))
	    while (!isdigit(*trueline) && *trueline) ++trueline;
	  snprintf(cmd, sizeof(cmd)-1, PATH_RSH " '%s'%s%s 'show line %s'",
		   u.ut_host,
		   (nas_new->rshuser) ? " -l " : "",
		   (nas_new->rshuser) ? nas_new->rshuser : "",
		   trueline);

	  /* report(LOG_DEBUG, "reg_nas_users: ip check: run %s", cmd); */

	  if ((buf = call_rsh(cmd))) {
	    if (!regexec(&rship_re, buf, 2, pmatch, 0)) {
	      *(buf+pmatch[1].rm_eo) = '\0';
	      strcpy(nasinfo, u.ut_host);
	      strcat(nasinfo, "/");
	      strncat(nasinfo, u.ut_line, 16);
	      if (debug & DEBUG_ACCT_FLAG)
		report(LOG_INFO, "sending login notification for %s (%s)", u.ut_user, buf+pmatch[1].rm_so);
	      dyna_req(u.ut_user, buf+pmatch[1].rm_so, nasinfo, 2);
	      u.ut_addr.s_addr = inet_addr(buf+pmatch[1].rm_so);
	    } /* else
	      report(LOG_ERR, "ip info not found user=%s, nas=%s, line=%s",
		     u.ut_user, u.ut_host, u.ut_line); */
	    free(buf);
	  } else report(LOG_DEBUG, "reg_nas_users: error reading rsh data user=%s, nas=%s, line=%s",
			u.ut_user, u.ut_host, u.ut_line);
#endif
	  if ((tty = t_ttyslot(u.ut_line, u.ut_host, alias, &trueline, &status)) > 0)
	    logintac(u.ut_user, u.ut_time, u.ut_host, alias, u.ut_line,
		     trueline, tty, status, u.ut_addr, ACCT_TYPE_START);
	  free(alias);
	}
    }
    free(buf);
}

#if 0
    for(j=0;j<nnas;j++)
	free(pnas[j]);
#endif

    endttyent();
}
